//Prefs

if (isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

	RTB_registerPref("Admin Status", "Noclip", "$Pref::Noclip::Status", "list None 0 Admin 1 Super 2 Host 3", "Script_NoClip", 1, 0, 1);
	RTB_registerPref("Allow in minigame", "Noclip", "$Pref::Noclip::Minigame", "bool", "Script_NoClip", 1, 0, 1);
}
else //RTB not found.
{
	//Defining prefs for non-RTB users.

	$Pref::Noclip::Status = "1";
	$Pref::Noclip::Minigame = "1";
}

//Prefs

datablock ItemData(NoclipItem)
{
	shapeFile = "base/data/shapes/empty.dts";
};
function NoclipItem::onCollision(){}
function NoclipItem::onPickup(){}

package Noclip
{
	function Armor::onTrigger(%this, %plr, %trig, %tog)
	{
		//FORWARD
		if(%trig == 2 && %tog == 1)
		{
			if(%plr.noclip)
			{
				%plr.clip = 1;
				NoclipLoop(%plr,%plr.noclipDist);
			}
		}

		if(%trig == 2 && %tog == 0)
		{
			if(%plr.noclip)
			{
				%plr.clip = 0;
			}
		}

		//BACK
		if(%trig == 3 && %tog == 1)
		{
			if(%plr.noclip)
			{
				%plr.clip = 1;
				NoclipLoop(%plr,-(%plr.noclipDist));
			}
		}

		if(%trig == 3 && %tog == 0)
		{
			if(%plr.noclip)
			{
				%plr.clip = 0;
			}
		}

		Parent::onTrigger(%this, %plr, %trig, %tog);
	}

	function NoclipLoop(%plr, %val)
	{
		if(%plr.noclip)
		{
			%pos = %plr.getTransform();
			%add = vectorScale(%plr.getEyeVector(), %val);
			%newtrans = vectorAdd(getWords(%pos, 0, 2), %add) SPC getWords(%pos, 3, getWordCount(%pos));
			%plr.noclip.setTransform( getWords(%newtrans,0,2) SPC getWords(%plr.noclip.getTransform(),3,6));
			//Huge thanks to Ipquarx for this code.

			if(%plr.clip)
				schedule(15,0,NoclipLoop,%plr,%val);
		}
	}

	//$Pref::Noclip::Status = "1"; //0, 1, 2, 3
	//$Pref::Noclip::Minigame = "1"; //0, 1

	function ServerCmdNoclip(%cl,%distance)
	{
		if(%cl.getControlObject() == %cl.camera)
		{
			%cl.chatMessage("ERROR: Noclip is disabled while in F8 mode.");
			return;
		}

		if(!isObject(%cl.player))
			return;

		if(%cl.player.isMounted() && !isObject(%cl.player.noclip))
			return;

		if(%cl.bl_id != getNumKeyID())
			if(!($Pref::Noclip::Status <= %cl.isAdmin + %cl.isSuperAdmin))
			{
				%cl.chatMessage("ERROR: Admin status not high enough to use this command.");
				return;
			}

		if(!(%distance >= 0.01 && %distance <= 10.01))
		{
			%cl.chatMessage("ERROR: Invalid distance value set.");
			return;
		}

		if(!($Pref::Noclip::Minigame) && %cl.minigame)
		{
			%cl.chatMessage("ERROR: Noclip is currently disabled while in a minigame.");
			return;
		}

			%item = new Item()
			{
				dataBlock = NoclipItem;
				position = %cl.player.position;
				rotation = %cl.player.rotation;
				static = 1;
			};

			if(%cl.player.noclip)
			%cl.player.noclip.delete();

			MissionCleanup.add(%item);
	
			%cl.player.noclip = %item;
			%cl.player.noclipDist = %distance;

			%item.hideNode("ALL");
			%item.mountObject(%cl.player,1);
	}

	function Armor::OnUnMount(%this, %plr, %col, %slot)
	{
		if(%plr.noclip)
		{
			%plr.noclip.delete();
			%plr.noclip = "";
			%plr.noclipDist = "";
		}
		Parent::OnUnMount(%this,%plr, %col, %slot);
	}

	function serverCmdDropCameraAtPlayer(%cl)
	{
		if(%cl.player.noclip)
		{
			%cl.chatMessage("ERROR: F8/F7 is disabled while in noclip mode.");
			return;
		}

		Parent::serverCmdDropCameraAtPlayer(%cl);
	}
};
activatePackage(Noclip);